//--------------------------------------
// C++ - LEZIONE 3 | Gli operatori
//--------------------------------------
         
#include <iostream.h>

void main() {

//A. Dichiariamo le nostre variabili

int var_uno = 5;
int var_due = 3;
int var_tre = 6;

//Facciamo qualche operazioni
cout << "La variabile 1 sommata alla 3: " << var_uno + var_due << "\n";
cout << "La v. 1 sottratta alla 3: " << var_tre - var_uno << "\n";
cout << "La v. 1 moltiplicata per la 2: " << var_uno * var_due << "\n";
cout << "La v. 1 divisa per la 2: " << var_uno / var_due << ", resto " << var_uno % var_due << "\n\n";

//--------------------------------------

//B. Usiamo "++", "--" e "="

int var_quattro = 1;
int var_cinque = 1;

//Il "++" prima la variabile
cout << "La variabile var_quattro con ++ prima della variabile: " << ++var_quattro << "\n";

//Il "++" dopo la variabile
cout << "La variabile var_cinque con ++ dopo la variabile: " << var_cinque++ << "\n";
cout << "La variabile var_cinque dopo essere stata stampata: " << var_cinque << "\n\n";

//--------------------------------------

//C. Alcune comparazioni con relativo valore true o false

cout << "LEGENDA\n1 espressione vera\n0 espressione falsa\n\n";
cout << "1 == 1: " << (int)(1 == 1) << "\n";
cout << "1 != 1: " << (int)(1 != 1) << "\n";
cout << "1 > 1: " << (int)(1 > 1) << "\n";
cout << "1 <= 1: " << (int)(1 <= 1) << "\n";
cout << "1 + 1 == 2 && 1 - 1 == 2: " << (int)(1 + 1 == 2 && 1 - 1 == 2) << "\n";
cout << "1 + 1 == 2 || 1 - 1 == 2: " << (int)(1 + 1 == 2 || 1 - 1 == 2) << "\n\n";

//--------------------------------------

//D. Esempi di precedenze nelle operazioni di calcolo

int var_sei = 3;
int var_sette = 8;
int var_otto;

//Esempio "()"
cout << "(var_sette - var_sei) * var_sette = " << (var_sette - var_sei) * var_sette << "\n";
//Esempio di "?:" (bassa precedenza):
//se var_sette  strettamente maggiore di var_otto allora var_otto diventer uguale a var_otto + 12
var_otto = (var_sette > var_otto) ? var_otto + 12 : var_otto;
cout << "L'esempio con ?: restituisce " << var_otto << "\n";
//Esempio "%"
var_otto = (var_sei + var_sette) % var_sei;
cout << "L'esempio con % restituisce " << var_otto;

//Questo serve a far s che la funzione void si chiuda solo quando l'utente preme Invio
cin >> var_uno;

}